stages:
  - build and push
  - test
  - cleanup
  - deploy 

image: docker:latest
services:
  - docker:dind

variables:
  DOCKER_DRIVER: overlay2  

before_script:
  - docker version
  # docker login asks for the password to be passed through stdin for security
  # we use $CI_REGISTRY_PASSWORD here which is a special variable provided by GitLab
  # https://docs.gitlab.com/ce/ci/variables/predefined_variables.html
  - echo -n $CI_REGISTRY_PASSWORD | docker login -u $CI_REGISTRY_USER --password-stdin $CI_REGISTRY  

build:
  stage: build and push
  script:
    - docker build --tag $CI_REGISTRY/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME:$CI_COMMIT_REF_SLUG.$CI_PIPELINE_ID .
    - docker push $CI_REGISTRY/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME:$CI_COMMIT_REF_SLUG.$CI_PIPELINE_ID

test:
  stage: test
  image:
    name: docker/compose:latest
  services:
    - docker:dind
  script:
    - docker-compose -f docker-compose.yml  -f docker-compose.test.yml up --abort-on-container-exit --exit-code-from test    

cleanup:
  stage: cleanup
  image:
    name: docker/compose:latest
  services:
    - docker:dind
  script:
    - docker-compose down
  when: always  

deploy:
  stage: deploy
  script:
    - echo 'deploy'
